diff --git a/benchtests/Makefile b/benchtests/Makefile
index 5470be7f40..fd4ed5270c 100644
--- a/benchtests/Makefile
+++ b/benchtests/Makefile
@@ -159,6 +159,10 @@ bench-pthread := \
   thread_create \
   # bench-pthread
 
+bench-resolv := \
+  inet_ntop_ipv4 \
+  # bench-resolv
+
 LDLIBS-bench-pthread-mutex-lock += -lm
 LDLIBS-bench-pthread-mutex-trylock += -lm
 LDLIBS-bench-pthread-spin-lock += -lm
@@ -418,6 +422,7 @@ ifeq (${BENCHSET},)
 bench := \
   $(bench-math) \
   $(bench-pthread) \
+  $(bench-resolv) \
   $(bench-string) \
   # bench
 else
diff --git a/benchtests/inet_ntop_ipv4-inputs b/benchtests/inet_ntop_ipv4-inputs
new file mode 100644
index 0000000000..0ca5e20fa6
--- /dev/null
+++ b/benchtests/inet_ntop_ipv4-inputs
@@ -0,0 +1,1003 @@
+## args: uint32_t
+## include-sources: inet_ntop_ipv4-source.c
+## name: workload-ipv4-random
+0xa5da31b5
+0xc0446e8b
+0x784b9c08
+0xb576afa1
+0x02d2ea9f
+0x4d82ba91
+0xd58a6a63
+0x931a078e
+0x8da553ca
+0xb995e341
+0xab1d3b82
+0x81b87ecf
+0xcd80ca63
+0x2896ed22
+0x8f207762
+0x9f944467
+0x3938ee1f
+0x248059e9
+0xf7333bf7
+0x711e3784
+0xe8becd9d
+0x3a2c5b73
+0x52cdb591
+0x6de2770a
+0x6d6019b1
+0x0cec9b4d
+0x0314b741
+0x3b8dbc18
+0x70becb0f
+0x1fbe2fa7
+0xbbf78a3c
+0x31ad5bbe
+0x5e4539a3
+0xf896555c
+0xe76bcfb5
+0xf8763851
+0xc309adee
+0x31abf300
+0xbba16c8e
+0x587ec525
+0x7507757e
+0xad7f20f3
+0x2e491154
+0xd1026261
+0x90d1bfe6
+0x21b62d60
+0x924edbc8
+0x06ded57e
+0x6e44ee05
+0x4d946fcc
+0x721b295c
+0x18bb6572
+0xdf64dc6f
+0x787912f1
+0x513254ae
+0x9a187f07
+0xbd19260d
+0x2d13f388
+0x72314a5e
+0xd49d1fe6
+0x58a21afd
+0x7265d9ad
+0x0db1242f
+0xda77990a
+0x225dd3f2
+0x7086fbc3
+0xcfa53a4c
+0xa95879e1
+0x1f22dcbf
+0xf2f95ae5
+0x32e55e15
+0x619cc022
+0xcbbc5903
+0x823cdaef
+0xbbc8e074
+0xd4b1abd1
+0xf4cc3b48
+0x54cadfc6
+0x7302fe22
+0x1866356d
+0x9af0f3d4
+0x150d45b7
+0x68d16537
+0x6f9ccab6
+0x30b5aa34
+0xb36e4558
+0xdf464fec
+0xfd553e8b
+0xe2d2b424
+0x401c0d14
+0xfeb219be
+0xe5503a5f
+0xf723b07c
+0x8f82f930
+0x91549eb0
+0xf15125b6
+0xfe746998
+0x5108da05
+0xc955eac0
+0x55132480
+0x6d476b2c
+0xec40f154
+0x91023884
+0xe1a9b815
+0x354daf94
+0x3dfed7ea
+0x2a4e8946
+0xcf9f3e6d
+0xa8041a9f
+0x4d116a0f
+0x31485a57
+0x2986e38a
+0x71c98c92
+0x95b1cf56
+0x02efa54a
+0x21d60c27
+0xe1ff084f
+0x9ea9d2a9
+0xa7a276fb
+0xdd540e04
+0xef5a28de
+0x959e2c45
+0x04e3297e
+0x7f353413
+0x98255f00
+0x8fef4195
+0xd1cf2a83
+0xe01c79fa
+0x8206c984
+0xa4d553b8
+0xb38cf863
+0xf9dc5da0
+0x740123a9
+0x469e28aa
+0xa94d5c0e
+0x099aefa6
+0x42f9ac05
+0xb5fa21a6
+0x605ba8b5
+0xd90eb999
+0xecaa6678
+0x876bd267
+0x584a9246
+0xe8bc8943
+0xba05331a
+0x5a1f8d08
+0x599a1d30
+0xc953fbc2
+0xa62b1bf5
+0x92f13ea2
+0x5260c6a6
+0x6f737ee7
+0x97ed7cf4
+0x1bafedd7
+0xf1c6ba92
+0xc738233a
+0x3c53e713
+0xc2c4f37e
+0x8922083b
+0xa699f915
+0x171a81f9
+0x9bd445c3
+0x582a213b
+0x7f9e6a68
+0xef4f3873
+0x61b6b3fb
+0xa1774a88
+0x5d142b71
+0xea8806dd
+0x37414744
+0x77d3e9a5
+0xdc2806a5
+0xec47420e
+0xaaf9388c
+0xe8ae4a58
+0xd68d3d03
+0x803cae48
+0xfff158dd
+0x0ab7b409
+0x3e1a797f
+0xcaa56e9c
+0xd3b4d996
+0xde20095e
+0x2e6820a4
+0x40e3b4ba
+0x038c5c95
+0x595bcab1
+0x25e23325
+0xb5debde0
+0xd95af591
+0x4750d367
+0xcaa82409
+0xbff0c5f8
+0x7ea63ac5
+0xacc6dce9
+0x08b1578e
+0x31544ded
+0xcbfaa140
+0xff149214
+0x29e4cdd9
+0x73277dba
+0x8150630e
+0xee66e89a
+0xff71f280
+0x2744a947
+0x9d71d581
+0x50d74a61
+0xb3f4cdb0
+0x2591b7c9
+0xa9f246ac
+0xaee36992
+0xa3777eca
+0xf642ae36
+0x9873836b
+0x0e9e0aa0
+0x1cb9a1ef
+0xeb6670fd
+0xe34ddf2b
+0x40cf1014
+0x8f8d532c
+0x2b1e2fec
+0x658f6ef4
+0x9117db64
+0xd8ffc94a
+0xbbce24da
+0x259029d5
+0xfff5bdc7
+0xfb7359e2
+0xf09be114
+0xda873a2b
+0x43ef9ca3
+0xafcfcce8
+0x4b14e050
+0xb7ef4c29
+0x2e8921fb
+0x1dc912d9
+0x946fd27e
+0xb6eb2bc3
+0x40ae2332
+0x373008ab
+0x8d1f0f0c
+0x1098cef6
+0x33dfa381
+0x6278717b
+0x8cfbfdc0
+0x6e4fafb5
+0x3e107d03
+0x8b82d5d4
+0xb3c70294
+0x4f5dfaf4
+0x13f862a1
+0xc03845f1
+0xe1645e9f
+0x620a157e
+0x27a318c5
+0xc6a1fd96
+0x01043a6c
+0xee82aebe
+0x77f9bcc7
+0xb0d67169
+0x5106f72a
+0xe1519086
+0x8e6d09c3
+0x2d35991b
+0xad33888a
+0xd281a2ce
+0x70094cdc
+0x09aee178
+0xb7a988d1
+0x7904d40a
+0xd505cebd
+0x5fc4744b
+0xd68e7e6e
+0x319c19db
+0x2c20f498
+0x5eefe1ac
+0x78107b15
+0x5d2c14a3
+0x8c352429
+0x98be10d6
+0x19fd3aa2
+0xdc151452
+0xd4f815ce
+0x40f9d4d8
+0x70922d99
+0xf3bc698a
+0x693e4c96
+0x5cd85948
+0x152565d9
+0x4673c6d2
+0xf26a8869
+0xeccdee1e
+0x2558149c
+0x32ed00cf
+0xccc8c08a
+0x6bb7e3ef
+0xd48bb23a
+0x11a7767a
+0x94e3fc39
+0x142ab220
+0x495ef56b
+0x5e0b1723
+0x7bf26602
+0xda933551
+0x3d9a9c93
+0x710a1aed
+0x0f3dbe35
+0x1fadfb03
+0xc42ce7ce
+0x34c4aac6
+0x422ea139
+0x9f37c92a
+0x28e80d7e
+0x7ac19552
+0x9b7c5bd2
+0x64ebdbf2
+0xdfcf3512
+0x1738765e
+0xd813cc0a
+0xf4d56f0e
+0x18f4dea7
+0xad277bf3
+0xa8fb80e7
+0xfbcd2419
+0x21f193f9
+0x2e9aef5d
+0x161cdc5b
+0x517e55ed
+0xb4cf6787
+0xc093cece
+0xa50fdca8
+0x0d8950d9
+0xd1d37d33
+0x822508b9
+0x60a3c4c6
+0x374d271b
+0xcea8f60e
+0xf4c0ccaa
+0x93affaab
+0x234a8e2e
+0xaf46d13e
+0xbdbd788f
+0x80c185d6
+0xade21b1f
+0xa9bb3117
+0x5f1e204f
+0x837b7278
+0xde83f661
+0x0e5a6d49
+0x06fdf305
+0xbad99c55
+0xf1c0b007
+0x6670d798
+0xaea379a9
+0xd2707d28
+0xf37ef4a8
+0x73e2534b
+0xe49f4fca
+0x91ad5854
+0x983540ce
+0x3179618f
+0xcb43e37d
+0x1a60cc04
+0x9cb2b42c
+0x5bc5d477
+0x298c8af2
+0x598fdb6e
+0xead6ed6e
+0x39264dc4
+0xbe2ded13
+0x9f75105a
+0xa854b5a8
+0x489686a8
+0x9f10a548
+0x4af5eb0b
+0x1c0d5f3d
+0x979eb255
+0x0a998273
+0x96d9cdfb
+0xb153737d
+0x8b8197b5
+0xb0af9d15
+0x53beec22
+0x47267074
+0xee08fee3
+0xa58581ba
+0x42c2d63d
+0x48a5105e
+0x4e1cb416
+0xb351b511
+0xf6da2304
+0x829f9f57
+0x06246258
+0xb78e2e76
+0xd7b3075e
+0x39af4dd5
+0x4de2271c
+0x2258853d
+0xfe857499
+0xed16ca3c
+0x51b77690
+0x91320d13
+0x8f7df385
+0x6563a1d8
+0xa9627f9f
+0xab8453ba
+0xf63b7678
+0xcbfc4991
+0x1ace8191
+0x4a341adf
+0x1e40a45d
+0x46d1807c
+0x92505c89
+0x6855a1ad
+0xa4fa9549
+0x1673a0a8
+0x6af29474
+0x760c8bc3
+0x48bc6521
+0xe871db92
+0x6fbcc444
+0x6dedbc0c
+0xde2d7351
+0x22b8fc16
+0x323bd522
+0xb935bcf5
+0x931e43c0
+0xdffa2198
+0xc1d19b85
+0xf60500b4
+0xd094c23d
+0xb7970257
+0x607f1b7d
+0x97e2eecb
+0x941fa489
+0xfae425c7
+0x64ffc9a3
+0x9482b9ba
+0xb489d435
+0x349452df
+0x5ffeec2d
+0x32b3584c
+0x3e548467
+0x530d9e32
+0x569353dd
+0xf4747702
+0xd856bd4e
+0x1bfc0426
+0x34e60c9b
+0xfe485d81
+0x7b184ad1
+0x1d307393
+0x4d21f87d
+0x492808a5
+0x9e857cbb
+0x6197f915
+0x80bb7d6a
+0x1aeb5dfb
+0xc7d4c551
+0x6c039c4f
+0x40f7c95e
+0x01322b6e
+0x35ee3d94
+0x399bfefc
+0x03b71c31
+0xa135ba00
+0x22e7b8bf
+0xd8e37293
+0x1ef10ddc
+0x5c4f977f
+0x32cbb232
+0x3746c6de
+0x7d37f74b
+0x2812718c
+0xa7c4873c
+0x8d8c7d79
+0x19007a1e
+0x4c785e68
+0xfb4849b3
+0x4c73c0c2
+0xe5ca4a89
+0x563af045
+0x08e67f32
+0x1af10bc6
+0xcb1697b0
+0xe4855c82
+0xbcf70a5c
+0x4bbec148
+0x7449d1c9
+0xe309b641
+0x72dab52e
+0xd73bcd11
+0xa50619ce
+0x9d13e90e
+0x15196926
+0x87f387a0
+0x0360b492
+0xbec6a221
+0x9d4f153f
+0x2ef40495
+0xa1fc8ec0
+0x3e7f36eb
+0xe5bdecc0
+0x2567db2e
+0x9e15fd71
+0xf9239150
+0xda4a4a28
+0xedb5b4b1
+0xb169302d
+0x81d1bc0a
+0xda01fc0f
+0xd9523ad0
+0x75c995cd
+0x4e7c5fd4
+0x1ccdacf4
+0x9e3409a6
+0xddb5f406
+0x39ae2258
+0x685eaef8
+0x27ec63ee
+0xc76f84fb
+0x0b1a116c
+0x7fcabb8a
+0xb6a1884b
+0x7c7a8a41
+0x8c741a5d
+0x6d61784e
+0x6fefe2d7
+0xdefa0e7f
+0xc8bf47d6
+0xd3972e7e
+0xf9f55896
+0x665b924a
+0x66f07987
+0x9a36fe39
+0xa52d6389
+0x985288c4
+0x776b1b14
+0x3b2b5df3
+0x8230278a
+0x4e20943b
+0xf194f3cd
+0x1923ba51
+0x0c161e54
+0x273c499c
+0x4893dfd1
+0x5d8d10c4
+0x912bccef
+0x37b3b8f2
+0xc9259773
+0xce403126
+0xaf67e43c
+0xb11526bb
+0x8e00961f
+0xd9309328
+0xf8fda5d4
+0x32cc9da3
+0x1ef0a26e
+0x1c2a4a6f
+0x40f252f5
+0x3c10be9f
+0xa4700a26
+0x6c2bf2db
+0xd6931843
+0x187457ca
+0x8c447237
+0x9b01fc11
+0x2e98780d
+0xa37b95e3
+0x22548e5f
+0x564ef6a8
+0x392dd4b2
+0xbbcad1ff
+0xa421f4ea
+0xba9af4b6
+0x471cdbcc
+0x4f1a388b
+0x2f9ace06
+0x03921467
+0x9cbfb693
+0x814ddaa6
+0x503644f8
+0x8695c3be
+0x61536ebb
+0x60c00244
+0x38f853d7
+0x57cb8520
+0xcfd2f868
+0xbaee2187
+0x9da049a8
+0x1f174bcd
+0x80e1d699
+0x14293276
+0xeb1a01b2
+0xaf04c079
+0xc2fd2db5
+0xdd55d0cc
+0x0c6cc6ef
+0xe13e3e22
+0xaad6f909
+0x69431d77
+0x614c55d5
+0xa8e99ef2
+0x5b69aae9
+0x1e793ce2
+0x33eac24f
+0x834aa80f
+0x243997d2
+0x85d08fd6
+0xe8bb04fb
+0x400b12f7
+0x4ac67a29
+0xc8c04fc3
+0xcbf8ef42
+0x3bbee941
+0xd46ed2fd
+0xdde37b5c
+0x0d853dee
+0xc94038f2
+0x8e573a21
+0x5e89e1db
+0xe273ddf1
+0xfadea3ca
+0xd2e51c7c
+0x2983594f
+0xe9db618a
+0xbb38a3c9
+0xe4abd34b
+0xfceacb94
+0x943aba94
+0x4f66eafd
+0xe6c0dce6
+0x7be21d78
+0x74337a51
+0xb68da494
+0x436c8bb8
+0x1d09c81a
+0xa62f5dda
+0x1aec137b
+0x2077e121
+0x352d8ed7
+0xa028eee9
+0x22813dfc
+0xcdf67fa5
+0xfda12a9d
+0x662d23dd
+0x9f56ece2
+0xa8bb39f8
+0xf3f4ca31
+0xda299ddb
+0xab321bc9
+0x79dce44b
+0x4bf75128
+0xb1fa5c10
+0xac19c3ca
+0xb2bd1cc7
+0x7bc86a3b
+0xe0c00cdf
+0xedbad3b3
+0x594f47ee
+0x075ab899
+0xd3960dd8
+0xc8b0d906
+0x03b349af
+0x1919a343
+0x104194ad
+0xb20aa561
+0xc45fa6e5
+0x3466ff76
+0x2a0a5f54
+0x76653805
+0x98bc7f9c
+0xe1139106
+0xa8389a71
+0x663cfff8
+0xd98cfad3
+0x8e17de21
+0x23f69152
+0x4b91dff2
+0x79ff012f
+0x5922c1c1
+0x116e15e1
+0xe36c89c2
+0x8dd2b853
+0x387b2f8c
+0xdbcbf47e
+0x6bf70fb9
+0x816db883
+0xa426dc13
+0x9a880e96
+0x67d5583d
+0xb3c12057
+0xdd0d22e3
+0x2fb43bbd
+0x340614c8
+0x1e044117
+0x35fc3d6a
+0x42fb3db4
+0xbd8ee31b
+0xd905e1ba
+0xe76fcf60
+0x261a3bf3
+0x08a5cdc0
+0x87dfba54
+0x374c0896
+0x9ef55ad4
+0x3a0614fe
+0x8d3372b2
+0x717f8d95
+0x1255bd89
+0xce2ecb9e
+0x877e33ab
+0x66dd165d
+0x0d6a31b2
+0x0846b0f3
+0x7a4f7992
+0xa946fdba
+0xfe7bd234
+0x787ec7f8
+0x593d2c82
+0xeef4a314
+0xa5acac01
+0x215492a2
+0x734e2de7
+0x05ddf8c5
+0x4a751f93
+0x2fc22c6e
+0x868492f4
+0x361f5df9
+0xe7882dae
+0xb5521966
+0xecfd094d
+0xade14805
+0xc6e74741
+0xe4334fac
+0xc79ddde0
+0x29e0bad2
+0xc26da1e5
+0x2ceac45e
+0x662dd065
+0xc7d732b6
+0xbedacf38
+0x7e178c0f
+0x250f56e5
+0x6d3cae24
+0x7be42fb5
+0x2f0181ba
+0xb07745f9
+0x36a363fc
+0xe104fa08
+0x6c92c379
+0xc1dab0eb
+0x012d850d
+0x8b30ded3
+0x1ceb4f74
+0xc6474a0d
+0x426b18a5
+0x8134b4b8
+0x9aba46a5
+0x0f615a99
+0xca2cb595
+0xde4ceaff
+0xb07c55b0
+0x6b461b61
+0x77d47aec
+0x713ccd15
+0x144f02a3
+0x98dbbec1
+0xd3cfa215
+0xe2be01d4
+0xa1e7612a
+0x4f63223d
+0x55a45013
+0x8d5f9526
+0x4f56252d
+0xe79994f6
+0xc1d2f899
+0x43fc9cb1
+0x6e593540
+0x1c480d66
+0x29a45a98
+0x1c778b80
+0x2fe5748b
+0xc42b1a8c
+0x84d82db6
+0xe234d779
+0x53cc2d3d
+0x2e0753ca
+0xea7c29ee
+0xd1baacdc
+0x0881e994
+0xa96f5873
+0x3a540ab0
+0x644c0daa
+0xfbed1c47
+0x0200b1bb
+0x19f3d066
+0x4d4a21d9
+0xc659473f
+0xb5afa485
+0xb1d92a44
+0x1ccffa38
+0xddadda5c
+0xb8478606
+0x7726d254
+0xb9f51015
+0xf1ccf5d0
+0xe9e4324d
+0x3330bacb
+0x75eb08d2
+0x9daaaca2
+0x877da369
+0xd41b8d85
+0x5aa83ea8
+0xfce6f734
+0xac2d5035
+0x847a0468
+0x3df04c98
+0xde4ed62a
+0x78a76589
+0x2b3215e7
+0x181f3a5e
+0x610f0e99
+0x6b95e44c
+0x990743d1
+0xb5ed2257
+0x3b516ec6
+0x71bc6e83
+0x447665fc
+0x0c1d0de5
+0x66b2a479
+0xea2502aa
+0xce222a1c
+0x6974ee5c
+0x74470d06
+0x1a208879
+0x107f95b1
+0xe5975ed3
+0x96928e1c
+0x7fe84e1b
+0xc85a6056
+0x4a005cfd
+0xd7d97bb7
+0x9a23c5b0
+0xd0b7f4a9
+0xfd61a22a
+0xf8107003
+0xec63357c
+0xe89fc352
+0xabdfaf5e
+0x7c161c96
+0x9ea703d6
+0x556ae863
+0x03695ff1
+0x5ba06bc4
+0x907dacbb
+0xba297579
+0x983c7e47
+0xf1d3ce7e
+0x9274a5ef
+0xf4dae517
+0xc2d11106
+0x08323755
+0x585c7faa
+0xa36d0de2
+0x35ec9280
+0x64709d92
+0x5100906a
+0x7671dda5
+0x73f81121
+0xf28246e2
+0x08466cdf
+0x537e6791
+0x13efc923
+0xe9d24e9d
+0xd22fc0a4
+0xd59be5c9
+0xa3e52d63
+0x7464d9f3
+0x866e5618
+0xe75e46b6
+0x2cd15f24
+0x07494a14
+0x5b34be38
+0x2da10a27
+0x7b827711
+0xc2b8bdb8
+0x9f8deb86
+0x37b7e667
+0xc54692dd
+0x44179846
+0xd326fad8
+0x71a9d932
+0x7b8f17fe
+0x13d9ce59
+0x4a054101
+0xf866d958
+0xcd730d08
+0xb82ea973
+0x99800ca3
+0x44090dc0
+0x07272d2c
+0xc577fad1
+0x81c656fb
+0x543ebd82
+0x63d9f998
+0x41cad4d1
+0x5ec695a6
+0x6d2e8c4a
+0x9d47a964
+0xe9e19be0
+0x87524147
+0x6d94b687
+0x28998c92
+0xd5222e46
+0xa06f762d
+0x19f1b572
+0x7cbd4b3b
+0x067f6470
+0xd2e4a695
+0x003c78df
+0x274a4992
+0x7ff14a7f
+0x4179cb9c
+0x395eab4d
+0xec0723cf
+0x48e9197b
+0x812fc24a
+0x8b7e1a3d
+0x7a65730d
+0xcf036e17
+0x18437977
+0x1b45a0ca
+0xdc52cc7b
+0x7eec75bf
+0xa19d3e46
+0x3ef0de98
+0x9004569b
+0x2e8bc8b2
+0xba0d6d10
+0x1645bff8
+0x842bba26
+0x4661f344
+0x0ee549d6
+0xd09b8818
+0xac8d33e8
+0x553e4f3e
+0x1d0f1368
+0x3135e79a
+0x415d934e
+0xa81d576a
+0xb3828841
+0x6afed044
+0x5b9d934c
+0xe13c6e07
+0xc9a2623c
+0x900b7d1f
+0x4dc8f0b7
+0x8af660e2
+0x942b98ec
+0xc1c35ac5
+0x8bc17e39
+0x9da5b510
+0xaf90fff9
+0x890cb584
+0x4edb77a1
+0x200de01e
+0x3b94fc5a
+0x977a6bdd
+0xed432809
+0x66d6f6b3
+0x3aee997f
+0xe0dedca6
+0x0eba9d2c
+0x2b77cd8b
+0xc0a0387e
+0x5a4288d0
+0x8e1a6748
+0x88152e2a
+0x8922cc17
+0x3fc651d8
+0x0d7ad8cf
+0x0f2ddbf6
+0xefe1d16f
+0xab9bcacc
+0x3f12fac8
+0xa7907925
+0xf2877b7c
+0xdf86ae85
+0x2b10f4ad
+0x1c66eccd
+0x0ffe0460
+0x54b1d473
+0x4e0b1b78
+0xebf6a094
+0x210dd5a3
+0x02b08cd8
+0x04450c50
+0x6aa55f9a
+0x1528b220
diff --git a/benchtests/inet_ntop_ipv4-source.c b/benchtests/inet_ntop_ipv4-source.c
new file mode 100644
index 0000000000..c595c47b84
--- /dev/null
+++ b/benchtests/inet_ntop_ipv4-source.c
@@ -0,0 +1,10 @@
+#include <arpa/inet.h>
+#include <stdint.h>
+
+static void
+inet_ntop_ipv4 (uint32_t addr)
+{
+  struct in_addr saddr = { .s_addr = addr };
+  char dst[INET_ADDRSTRLEN];
+  inet_ntop (AF_INET, &saddr, dst, sizeof dst);
+}